'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PropTypes = require('prop-types');
var React = require('react');

var _require = require('react-redux'),
    Provider = _require.Provider;

var rootProviderSymbol = Symbol();

var RootProvider = function (_React$Component) {
	_inherits(RootProvider, _React$Component);

	function RootProvider() {
		_classCallCheck(this, RootProvider);

		var _this = _possibleConstructorReturn(this, (RootProvider.__proto__ || Object.getPrototypeOf(RootProvider)).call(this));

		_this[rootProviderSymbol] = true;
		return _this;
	}

	_createClass(RootProvider, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			if (!this.props.store) {
				throw new Error("Error Root Provider expects a store passed in as a prop");
			}

			var wrappedElements = [];
			if (Array.isArray(this.props.children)) {
				this.props.children.forEach(function (element, index) {
					if (!RootProvider.isRootProvider(element)) {
						wrappedElements.push(React.createElement(Provider, { key: index, store: _this2.props.store }, element));
					}
				});
			} else {
				wrappedElements.push(React.createElement(Provider, { key: 0, store: this.props.store }, this.props.children));
			}

			return React.createElement('div', null, wrappedElements);
		}
	}], [{
		key: 'isRootProvider',
		value: function isRootProvider(elem) {
			return elem[rootProviderSymbol];
		}
	}]);

	return RootProvider;
}(React.Component);

module.exports = RootProvider;

RootProvider.propTypes = {
	store: PropTypes.object.isRequired
};